/****************************************/
/*	Autor: Piotr Doniec 4I1     		    */
/*	pdoniec@stud.elka.pw.edu.pl      	 */			
/*	Temat: biblioteka stl,				    */
/*	algorytmy	adjacent_find     		 */
/****************************************/

/*
	template <class ForwardIterator> 
		ForwardIterator adjacent_find(ForwardIterator first, ForwardIterator last);
 
	template <class ForwardIterator, class BinaryPredicate> 
		ForwardIterator adjacent_find(ForwardIterator first, ForwardIterator last, BinaryPredicate binary_pred);
  
	-- Parametry --
	* first - iterator wskazujcy pocztek zakresu do przeszukania
	* last - iterator wskazujcy koniec zakresu do przeszukania
	* binary_pred - opcjonalny argument, wskanik na funkcj dokonujcej porwnania
*/

#include<algorithm>
#include<list>
#include<iostream>
 
/**
 * Sprawdza czy nastpny element jest 2 razy wikszy od obecnego
 * Funkcja podana jako trzeci argument algorytmu adjacent_find
 * spowoduje e kryterium rwnoci elementw bdzie spenione jeli
 * element bdzie 2 razy mniejszy od elementu po nim nastpujcego
 */
bool twice (int elem1, int elem2 )
{
   return elem1 * 2 == elem2;
}
 

 
int main() {
 
  /**
   * inicjalizacja struktur danych do demonstracji dziaania
	* algorytmu
	*/
  std::list<int> L;
  std::list<int>::iterator result, iter;
 
  //L.push_back(160);
  L.push_back(80);
  L.push_back(160);
  L.push_back(60);
  L.push_back(50);
  L.push_back(40);
  L.push_back(10);
  L.push_back(20);
  L.push_back(20);
  
  for(iter = L.begin(); iter != L.end(); iter++) {
    std::cout << *iter << " ";
  }
  std::cout << std::endl;
  
  
  /**
   * Najprostsze wykorzystanie algorytmu adjacent_find(), sprawdzajce 
	* czy istniej para, indentycnych kolejno wystpujcych elementw
	*/
  result = std::adjacent_find(L.begin(), L.end());
  if( result == L.end() ) {
    std::cout << "Nie istniej dwa kolejne identyczne elementy" << std::endl;
  }
  else {
    std::cout << "Isteniej dwa kolejne identyczne elementy o wartoci " << *result << std::endl;
  }
  
 
  /**
   * Wykorzystanie 3 argumentu algorytmu adjacent_find.
	* Dostarczona funkcja sprawdza czy istnieje para kolejnych elementw 
	* z ktrych pierwszy ma warto dwukrotnie wiksz od drugiego
	*/
  result = std::adjacent_find( L.begin(), L.end(), twice );
  if ( result == L.end() ) {
    std::cout << "Nie wystpuje para kolejnych elementw, w ktrej jeden element jest dwukrotnie wikszy od drugiego" << std::endl;
  }
  else {
      std::cout << "Wystpuje para elementw w ktrej jeden jest 2 razy wikszy od drugiego" << "\nWartoci tych elementw" << *(result);
      std::cout << " oraz " << *(++result) << std::endl;
  }
  
  /**
   * Prba odnaleziena drugiej pary elementw speaniajcej warunek rownoci zawarty w funkcji twice
	*/
  result = std::adjacent_find( result, L.end(), twice );
  if ( result == L.end() ) {
    std::cout << "Nie wystpuje para kolejnych elementw, w ktrej jeden element jest dwukrotnie wikszy od drugiego" << std::endl;
  }
  else {
      std::cout << "Wystpuje para elementw w ktrej jeden jest 2 razy wikszy od drugiego" << std::endl << "Wartoci tych elementw: " << *(result);
      std::cout << " oraz " << *(++result) << std::endl;
  }
}